import es

''' Information sur l'addons ''' 
info = es.AddonInfo()
info.name        = 'DebianSecurity'
info.author      = 'Debian'
info.basename    = 'debiansecurity'
info.url         = 'debian.evolution-prod.com'
info.description = 'Protege le serveur contre les menaces, le cheat, les crash serveurs & les lags'

denied_chars = ['\x03', '\x04', '\x09', '\x0B', '\x13']

block_list = [
'ping',
'version',
'server_game_time',
'rr_reloadresponsesystems',
'sv_soundemitter_flush',
'sv_soundemitter_filecheck',
'sv_findsoundname',
'sv_soundscape_printdebuginfo',
'ma_timeleft',
'nextmap',
'ma_client',
'ma_clientgroup',
'ma_unban',
'ma_showrestrict',
'physics_select',
'physics_debug_entity',
'sv_cheats',
'quit',
'mat_proxy',
'mat_wireframe',
'sv_consistency',
'mat_fillrate',
'mat_normals',
'r_screenoverlay',
'mat_fullbright',
'mat_depthbias_normal',
'r_drawstaticprops',
'r_colorstaticprops',
'r_showenvcubemap',
'ent_fire',
'ent_create',
'snd_show',
'snd_visualize',
'r_partition_level',
'r_drawbrushmodels',
'mem_force_flush',
'r_drawmodelstatsoverlay',
'r_shadowwireframe',
'r_visualizetraces',
'r_visualizelighttraces',
'r_drawlights',
'vcollide_wireframe',
'mat_normalmaps',
'mat_luxels',
'r_modelwireframedecal',
'sv_showplayerhitboxes',
'vgui_drawtree',
'host_framerate',
'mat_showlowresimage',
'npc_speakall',
'dumpentityfactories',
'dump_entity_sizes',
'dumpeventqueue',
'dbghist_addline',
'dbghist_dump',
'dump_globals',
'dumpcountedstrings',
'dump_terrain',
'mp_dump_timers',
'mem_dump',
'soundscape_flush',
'groundlist',
'report_touchlinks',
'report_entities',
'physics_report_active',
'scene_flush',
'_restart',
'ai_set_move_height_epsilon',
'ainet_generate_report',
'ainet_generate_report_only',
'cmd',
'exit',
'listmaps',
'listmodels',
'listRecentNPCSpeech',
'ListServerUserMessages',
'ma_favourites',
'ma_map',
'ma_showsounds',
'ma_version',
'memory',
'pcymd_register',
'quti',
'timeleft',
'wc_update_safe_entities',
'es_version',
'ai_clear_bad_links',
'ai_debug_node_connect',
'ai_dump_hints',
'ai_show_node',
'bench_end',
'bench_start',
'bench_upload',
'BindToggle',
'cache_print',
'cache_print_summary',
'cache_print_lru',
'cast_hull',
'cast_ray',
'cc_lookup_crc',
'collision_test',
'connect',
'CreatePredictionError',
'disconnect',
'dti_flush',
'dumpgamestringtable',
'dumpstringtables',
'ent_debugkeys',
'est_CloseFile',
'ent_dump',
'est_Credits',
'est_DeleteLine',
'est_InsertLine',
'est_OpenFile',
'est_PrintOpenFile',
'flush',
'flush_locked',
'host_runofftime',
'kdtree_test',
'killserver',
'ma_nextmap',
'mat_configcurrent',
'mat_reloadallmaterials',
'mem_compact',
'mem_eat',
'mem_vcollide',
'notarget',
'npc_ammo_deplete',
'npc_freeze',
'npc_go',
'npc_heal',
'npc_teleport',
'npc_thinknow',
'npc_vphysics',
'phys_swap',
'physics_budget',
'physics_highlight_active',
'prop_debug',
'r_flushlod',
'r_mmx',
'r_printdecalinfo',
'r_sse',
'r_sse2',
'report_simthinklist',
'xalias',
'report_soundpatch',
'restart',
'respawn_entities',
'scene_mem',
'snd_restart',
'sm_menu',
'surfaceprop',
'sv_precacheinfo',
'Test_CreateEntity',
'test_dispatcheffect',
'Test_EHandle',
'test_entity_blocker',
'Test_InitRandomEntitySpawner',
'Test_ProxyToggle_EnableProxy',
'Test_ProxyToggle_SetValue',
'Test_RandomizeInPVS',
'Test_RandomPlayerPosition',
'Test_RemoveAllRandomEntities',
'Test_SpawnRandomEntities',
'testlib',
'testprint',
'testtest',
'testsuite',
'vox_reload',
'voxeltree_playerview',
'vprof',
'vprof_cachemiss',
'vprof_cachemiss_off',
'vprof_cachemiss_on',
'vprof_dump_groupnames',
'vprof_generate_report',
'vprof_generate_report_AI',
'vprof_generate_report_AI_only',
'vprof_generate_report_hierarchy',
'vprof_off',
'vprof_generate_report_map_load',
'vprof_on',
'vprof_playback_average',
'vprof_playback_start',
'vprof_playback_step',
'vprof_playback_stepback',
'vprof_playback_stop',
'vprof_record_start',
'vprof_record_stop',
'vprof_reset',
'vprof_reset_peaks',
'vprof_vtune_group',
'wc_update_entity',
'r_drawothermodels',
'cl_leveloverview',
'r_rainspeed',
'cl_particles_show_bbox',
'r_drawparticles',
'r_drawrenderboxes',
'mat_normalmaps',
'fog_enable',
'mat_luxels',
'cl_pitchup',
'cl_pitchdown',
'cl_bobcycle',
    ]
    
def player_connect(ev):
    userid  = int(ev['userid'])
    name    = ev['name']
    for character in denied_chars:
        if character in name:
            es.server.queuecmd('kickid %i %s'%(userid, 'Bells (colored names) are not allowed on this server.'))

def load():
    es.addons.registerSayFilter(mizxSayFilter)
    for command in block_list:
        es.flags('add', 'cheat', command)
    es.set(info.basename, info.version)
    es.makepublic(info.basename)

def unload():
    es.addons.unregisterSayFilter(mizxSayFilter)
    for command in block_list:
        es.flags('remove', 'cheat', command)

def mizxSayFilter(userid, text, teamonly):
    text = text[1:-1]
    containsChar = 0
    for char in denied_chars:
        if char in text:
            containsChar = 1
            text = text.replace(char, text)
    if containsChar: es.tell(userid, '#multi', '#green[#lightgreenMizx Exploits#green] #defaultSorry, one or more of those characters you used are not allowed in this server.')
    return (userid, text, teamonly)